package combinatorParsing

/** This interface captures what parsers need to know about source positions.
 */
trait Positions {

  /** An unspecified type for positions */
  type Position

  /** An invalid position value */
  val NoPos: Position

  /** An ordering operation on positions */
  protected def precedes(pos1: Position, pos2: Position): boolean
}
