package tapl2

import combinatorParsing.{BuildingParsers, Position, TokenizingParsers}

/** This object implements a parser and evaluator for the
 *  untyped lambda calculus found in Chapter 5 of
 *  the TAPL book.
 */
object Untyped extends TokenizingParsers with BuildingParsers {
  // to be completed

  /** Term     ::= AbsOrVar { AbsOrVar }
   */
  def Term: Parser = production(
    // to be completed
    failure("illegal start of term"))

  // to be completed

  type Output = Term

  import implicitConversions._

  override def build(xs: List[Token], pos: Position): Output =
    null // to be replaced

  def parse(in: String): Option[Output] = {
    val res = run(Term, in)
    res match {
      case Success(_, _) => output(res)
      case Failure(_, _) => Console.println(res); None
    }
  }

  // to be completed

  def reduce(t: Term): Term =
    t // to be replaced

  def reduceWithCallByValue(t: Term): Term =
    t // to be replaced

  /** Returns a stream of terms, each being one step of reduction.
   *
   *  @param t      the initial term
   *  @param reduce the evaluation strategy used for reduction.
   *  @return       the stream of terms representing the big reduction.
   */
  def path(t: Term, reduce: Term => Term): Stream[Term] =
    Stream.empty // to be replaced

  def main(args: Array[String]): Unit = {
    val Some(p1) = parse("""\s.\z.s (s z)""")
    Console.println(p1)
    Console.println
    val Some(p2) = parse("""(\m.\n.m n) (\s.\z.s (s z)) (\s.\z.s (s (s z)))
                         """)
    Console.println("Full beta reduction:")
    for (val t <- path(p2, reduce)) Console.println(t)
    Console.println("Call by value:")
    for (val t <- path(p2, reduceWithCallByValue)) Console.println(t)
  }
}
